# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables


class NetworkConnectionMonitor(pulumi.CustomResource):
    auto_start: pulumi.Output[bool]
    """
    Will the connection monitor start automatically once created? Changing this forces a new Network Connection Monitor to be created.
    """
    destination: pulumi.Output[dict]
    """
    A `destination` block as defined below.

      * `address` (`str`) - The address of the connection monitor destination (IP or domain name). Conflicts with `destination.0.virtual_machine_id`
      * `port` (`float`) - The destination port used by connection monitor.
      * `virtual_machine_id` (`str`) - The ID of the virtual machine used as the destination by connection monitor. Conflicts with `destination.0.address`
    """
    interval_in_seconds: pulumi.Output[float]
    """
    Monitoring interval in seconds.
    """
    location: pulumi.Output[str]
    """
    The Azure Region where the Network Connection Monitor should exist. Changing this forces a new Network Connection Monitor to be created.
    """
    name: pulumi.Output[str]
    """
    The name which should be used for this Network Connection Monitor. Changing this forces a new Network Connection Monitor to be created.
    """
    network_watcher_name: pulumi.Output[str]
    """
    The name of the Network Watcher. Changing this forces a new Network Connection Monitor to be created.
    """
    resource_group_name: pulumi.Output[str]
    """
    The name of the Resource Group where the Network Connection Monitor should exist. Changing this forces a new Network Connection Monitor to be created.
    """
    source: pulumi.Output[dict]
    """
    A `source` block as defined below.

      * `port` (`float`) - The source port used by connection monitor.
      * `virtual_machine_id` (`str`) - The ID of the virtual machine used as the source by connection monitor.
    """
    tags: pulumi.Output[dict]
    """
    A mapping of tags which should be assigned to the Network Connection Monitor.
    """
    def __init__(__self__, resource_name, opts=None, auto_start=None, destination=None, interval_in_seconds=None, location=None, name=None, network_watcher_name=None, resource_group_name=None, source=None, tags=None, __props__=None, __name__=None, __opts__=None):
        """
        Manages a Network Connection Monitor.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_azure as azure

        example_resource_group = azure.core.get_resource_group(name="example-resources")
        example_network_watcher = azure.network.NetworkWatcher("exampleNetworkWatcher",
            location=example_resource_group.location,
            resource_group_name=example_resource_group.name)
        src_virtual_machine = azure.compute.get_virtual_machine(name="example-vm",
            resource_group_name=example_resource_group.name)
        src_extension = azure.compute.Extension("srcExtension",
            virtual_machine_id=src_virtual_machine.id,
            publisher="Microsoft.Azure.NetworkWatcher",
            type="NetworkWatcherAgentLinux",
            type_handler_version="1.4",
            auto_upgrade_minor_version=True)
        example_network_connection_monitor = azure.network.NetworkConnectionMonitor("exampleNetworkConnectionMonitor",
            network_watcher_name=example_network_watcher.name,
            resource_group_name=example_resource_group.name,
            location=example_network_watcher.location,
            auto_start=False,
            interval_in_seconds=30,
            source={
                "virtual_machine_id": src_virtual_machine.id,
                "port": 20020,
            },
            destination={
                "address": "mycompany.io",
                "port": 443,
            },
            tags={
                "foo": "bar",
            },
            opts=ResourceOptions(depends_on=[src_extension]))
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] auto_start: Will the connection monitor start automatically once created? Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[dict] destination: A `destination` block as defined below.
        :param pulumi.Input[float] interval_in_seconds: Monitoring interval in seconds.
        :param pulumi.Input[str] location: The Azure Region where the Network Connection Monitor should exist. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[str] name: The name which should be used for this Network Connection Monitor. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[str] network_watcher_name: The name of the Network Watcher. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[str] resource_group_name: The name of the Resource Group where the Network Connection Monitor should exist. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[dict] source: A `source` block as defined below.
        :param pulumi.Input[dict] tags: A mapping of tags which should be assigned to the Network Connection Monitor.

        The **destination** object supports the following:

          * `address` (`pulumi.Input[str]`) - The address of the connection monitor destination (IP or domain name). Conflicts with `destination.0.virtual_machine_id`
          * `port` (`pulumi.Input[float]`) - The destination port used by connection monitor.
          * `virtual_machine_id` (`pulumi.Input[str]`) - The ID of the virtual machine used as the destination by connection monitor. Conflicts with `destination.0.address`

        The **source** object supports the following:

          * `port` (`pulumi.Input[float]`) - The source port used by connection monitor.
          * `virtual_machine_id` (`pulumi.Input[str]`) - The ID of the virtual machine used as the source by connection monitor.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['auto_start'] = auto_start
            if destination is None:
                raise TypeError("Missing required property 'destination'")
            __props__['destination'] = destination
            __props__['interval_in_seconds'] = interval_in_seconds
            __props__['location'] = location
            __props__['name'] = name
            if network_watcher_name is None:
                raise TypeError("Missing required property 'network_watcher_name'")
            __props__['network_watcher_name'] = network_watcher_name
            if resource_group_name is None:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__['resource_group_name'] = resource_group_name
            if source is None:
                raise TypeError("Missing required property 'source'")
            __props__['source'] = source
            __props__['tags'] = tags
        super(NetworkConnectionMonitor, __self__).__init__(
            'azure:network/networkConnectionMonitor:NetworkConnectionMonitor',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, auto_start=None, destination=None, interval_in_seconds=None, location=None, name=None, network_watcher_name=None, resource_group_name=None, source=None, tags=None):
        """
        Get an existing NetworkConnectionMonitor resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] auto_start: Will the connection monitor start automatically once created? Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[dict] destination: A `destination` block as defined below.
        :param pulumi.Input[float] interval_in_seconds: Monitoring interval in seconds.
        :param pulumi.Input[str] location: The Azure Region where the Network Connection Monitor should exist. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[str] name: The name which should be used for this Network Connection Monitor. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[str] network_watcher_name: The name of the Network Watcher. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[str] resource_group_name: The name of the Resource Group where the Network Connection Monitor should exist. Changing this forces a new Network Connection Monitor to be created.
        :param pulumi.Input[dict] source: A `source` block as defined below.
        :param pulumi.Input[dict] tags: A mapping of tags which should be assigned to the Network Connection Monitor.

        The **destination** object supports the following:

          * `address` (`pulumi.Input[str]`) - The address of the connection monitor destination (IP or domain name). Conflicts with `destination.0.virtual_machine_id`
          * `port` (`pulumi.Input[float]`) - The destination port used by connection monitor.
          * `virtual_machine_id` (`pulumi.Input[str]`) - The ID of the virtual machine used as the destination by connection monitor. Conflicts with `destination.0.address`

        The **source** object supports the following:

          * `port` (`pulumi.Input[float]`) - The source port used by connection monitor.
          * `virtual_machine_id` (`pulumi.Input[str]`) - The ID of the virtual machine used as the source by connection monitor.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["auto_start"] = auto_start
        __props__["destination"] = destination
        __props__["interval_in_seconds"] = interval_in_seconds
        __props__["location"] = location
        __props__["name"] = name
        __props__["network_watcher_name"] = network_watcher_name
        __props__["resource_group_name"] = resource_group_name
        __props__["source"] = source
        __props__["tags"] = tags
        return NetworkConnectionMonitor(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
